#include "glwidget.h"
#include "ple.h"

#define CANVAS_WIDTH 512
#define CANVAS_HEIGHT 512

// --------------------------------------------------

void GLWidget::initializeGL()
{
    //initialization of OpenGL
    dvwindow(CANVAS_WIDTH, CANVAS_HEIGHT);
    glClearColor(0.85f, 0.85f, 0.85f, 0.f);
    glClear(GL_COLOR_BUFFER_BIT);
}

void GLWidget::paintGL()
{
    redraw(1);
}

void GLWidget::resizeGL(int width, int height)
{
    dvwindow(width, height);
    glViewport(0, 0, width, height);
}

QSize GLWidget::sizeHint() const
{
    return QSize(CANVAS_WIDTH, CANVAS_HEIGHT);
}

void GLWidget::mousePressEvent(QMouseEvent *event)
{
    if (event->button() == Qt::RightButton) {
        startmove(event->x(), dv_map_y(event->y()));
    }
}

void GLWidget::mouseReleaseEvent(QMouseEvent *event)
{
    if (event->button() == Qt::LeftButton) {
        addpoint(event->x(), dv_map_y(event->y()));
    } else if (event->button() == Qt::RightButton) {
        endmove();
    }
    updateGL();
}

void GLWidget::mouseMoveEvent(QMouseEvent *event)
{
    if (is_moving())
        movepoint(event->x(), dv_map_y(event->y()));
    updateGL();
}

void GLWidget::keyPressEvent(QKeyEvent *event)
{
    switch (event->key()) {
    case Qt::Key_Q:
    case Qt::Key_Escape:
        exit(0);
        break;
    case Qt::Key_D: {
        QPoint pt = mapFromGlobal(QCursor::pos());
        delpoint(pt.x(), dv_map_y(pt.y()));
    }
        break;
    case Qt::Key_C:
        delpoints();
        break;
    case Qt::Key_P:
        toggleshowpolygon();
        break;
    case Qt::Key_R:
        break;
    }
    updateGL();
}

